RTEMS: Timers

| RTEMS 5.4-rc2

Loading...
Searching...
No Matches
Files | Data Structures | Macros | Typedefs | Enumerations | Functions
Timers
API » Classic

## Files
file | timer.h
| Classic Timer Manager API.
file | rtemstimer.c
| Classic Timer Information with Zero Objects.
file | timercreate.c
| RTEMS Create Timer.
file | timerdelete.c
| RTEMS Delete Timer.
file | timerfireafter.c
| RTEMS Timer Fire After.
file | timerfirewhen.c
| RTEMS Timer Fire When.
file | timergetinfo.c
| RTEMS Get Timer Information.
file | timerident.c
| RTEMS Timer Name to Id.
file | timerreset.c
| RTEMS Timer Reset.
file | timerserverfireafter.c
| RTEMS Timer Server Fire After.
file | timerserverfirewhen.c
| RTEMS Timer Server Fire When Directive.

## Data Structures
struct | rtems_timer_information

## Macros
#define | TIMER_CLASS_BIT_TIME_OF_DAY 0x1
#define | TIMER_CLASS_BIT_ON_TASK 0x2
#define | TIMER_CLASS_BIT_NOT_DORMANT 0x4
#define | RTEMS_TIMER_SERVER_DEFAULT_PRIORITY (uint32_t) -1

## Typedefs
typedef void | rtems_timer_service_routine
typedef rtems_timer_service_routine(* | rtems_timer_service_routine_entry) (rtems_id, void *)

## Enumerations
enum | Timer_Classes { TIMER_DORMANT , TIMER_INTERVAL = TIMER_CLASS_BIT_NOT_DORMANT , TIMER_INTERVAL_ON_TASK , TIMER_TIME_OF_DAY , TIMER_TIME_OF_DAY_ON_TASK }

## Functions
rtems_status_code | rtems_timer_create (rtems_name name, rtems_id *id)
| RTEMS Create Timer.
rtems_status_code | rtems_timer_ident (rtems_name name, rtems_id *id)
| RTEMS Timer Name to Id.
rtems_status_code | rtems_timer_cancel (rtems_id id)
| rtems_timer_cancel
rtems_status_code | rtems_timer_delete (rtems_id id)
| RTEMS Delete Timer.
rtems_status_code | rtems_timer_fire_after (rtems_id id, rtems_interval ticks, rtems_timer_service_routine_entry routine, void *user_data)
| RTEMS Timer Fire After.
rtems_status_code | rtems_timer_server_fire_after (rtems_id id, rtems_interval ticks, rtems_timer_service_routine_entry routine, void *user_data)
| RTEMS Timer Server Fire After.
rtems_status_code | rtems_timer_fire_when (rtems_id id, rtems_time_of_day *wall_time, rtems_timer_service_routine_entry routine, void *user_data)
| RTEMS Timer Fire When.
rtems_status_code | rtems_timer_server_fire_when (rtems_id id, rtems_time_of_day *wall_time, rtems_timer_service_routine_entry routine, void *user_data)
| RTEMS Timer Server Fire When Directive.
rtems_status_code | rtems_timer_reset (rtems_id id)
| RTEMS Timer Reset.
rtems_status_code | rtems_timer_initiate_server (rtems_task_priority priority, size_t stack_size, rtems_attribute attribute_set)
| Initiates the timer server.
rtems_status_code | rtems_timer_get_information (rtems_id id, rtems_timer_information *the_info)
| RTEMS Get Timer Information.

## Detailed Description

This encapsulates functionality related to the Classic API Timer Manager. This manager provides functionality which allows the application to schedule the execution of methods at a specified time in the future. These methods may be scheduled based upon interval or wall time and may be executed in either the clock tick ISR or in a special dedicated timer server task.

## Macro Definition Documentation

## ◆ RTEMS_TIMER_SERVER_DEFAULT_PRIORITY

#define RTEMS_TIMER_SERVER_DEFAULT_PRIORITY (uint32_t) -1

This is the default value for the priority of the Timer Server. When given this priority, a special high priority not accessible via the Classic API is used.

## Typedef Documentation

## ◆ rtems_timer_service_routine

typedef void rtems_timer_service_routine

The following types define a pointer to a timer service routine.

## ◆ rtems_timer_service_routine_entry

typedef rtems_timer_service_routine(* rtems_timer_service_routine_entry) (rtems_id, void *)

This type defines the type used to manage and indirectly invoke Timer Service Routines (TSRs). This defines the prototype and interface for a function which is to be used as a TSR.

## Enumeration Type Documentation

## ◆ Timer_Classes

enum Timer_Classes

The following enumerated type details the classes to which a timer may belong.

Enumerator
TIMER_DORMANT | This value indicates the timer is currently not in use.
TIMER_INTERVAL | This value indicates the timer is currently in use as an interval timer which will fire in the clock tick ISR.
TIMER_INTERVAL_ON_TASK | This value indicates the timer is currently in use as an interval timer which will fire in the timer server task.
TIMER_TIME_OF_DAY | This value indicates the timer is currently in use as an time of day timer which will fire in the clock tick ISR.
TIMER_TIME_OF_DAY_ON_TASK | This value indicates the timer is currently in use as an time of day timer which will fire in the timer server task.

## Function Documentation

## ◆ rtems_timer_cancel()

rtems_status_code rtems_timer_cancel | ( | rtems_id | id | ) |

rtems_timer_cancel

This routine implements the rtems_timer_cancel directive. It is used to stop the timer associated with ID from firing.

## ◆ rtems_timer_create()

rtems_status_code rtems_timer_create | ( | rtems_name | name,
|  | rtems_id * | id
| ) |  |

RTEMS Create Timer.

This routine implements the rtems_timer_create directive. The timer will have the name name. It returns the id of the created timer in ID.

Parameters

  [in] | name | is the timer name
  [out] | id | is the pointer to timer id

Return values

  RTEMS_SUCCESSFUL | if successful or error code if unsuccessful

## ◆ rtems_timer_delete()

rtems_status_code rtems_timer_delete | ( | rtems_id | id | ) |

RTEMS Delete Timer.

This routine implements the rtems_timer_delete directive. The timer indicated by ID is deleted.

Parameters

  [in] | id | is the timer id

Return values

  This | method returns RTEMS_SUCCESSFUL if there was not an error. Otherwise, a status code is returned indicating the source of the error.

## ◆ rtems_timer_fire_after()

rtems_status_code rtems_timer_fire_after | ( | rtems_id | id,
|  | rtems_interval | ticks,
|  | rtems_timer_service_routine_entry | routine,
|  | void * | user_data
| ) |  |

RTEMS Timer Fire After.

This routine implements the rtems_timer_fire_after directive. It initiates the timer associated with ID to fire in ticks clock ticks. When the timer fires, the routine will be invoked in the context of the rtems_clock_tick directive which is normally invoked as part of servicing a periodic interupt.

Parameters

  [in] | id | is the timer id
  [in] | ticks | is the interval until routine is fired
  [in] | routine | is the routine to schedule
  [in] | user_data | is the passed as argument to routine when it is fired

Return values

  This | method returns RTEMS_SUCCESSFUL if there was not an error. Otherwise, a status code is returned indicating the source of the error.

## ◆ rtems_timer_fire_when()

rtems_status_code rtems_timer_fire_when | ( | rtems_id | id,
|  | rtems_time_of_day * | wall_time,
|  | rtems_timer_service_routine_entry | routine,
|  | void * | user_data
| ) |  |

RTEMS Timer Fire When.

This routine implements the rtems_timer_fire_when directive. It initiates the timer associated with ID to fire at wall_time When the timer fires, the routine will be invoked in the context of the rtems_clock_tick directive which is normally invoked as part of servicing a periodic interupt.

Parameters

  [in] | id | is the timer id
  [in] | wall_time | is the time of day to fire timer
  [in] | routine | is the routine to schedule
  [in] | user_data | is the passed as argument to routine when it is fired

Return values

  This | method returns RTEMS_SUCCESSFUL if there was not an error. Otherwise, a status code is returned indicating the source of the error.

## ◆ rtems_timer_get_information()

rtems_status_code rtems_timer_get_information | ( | rtems_id | id,
|  | rtems_timer_information * | the_info
| ) |  |

RTEMS Get Timer Information.

This routine implements the rtems_timer_get_information directive. This directive returns information about the timer.

Parameters

  [in] | id | is the timer id
  [in] | the_info | is the pointer to timer information block

Return values

  RTEMS_SUCCESSFUL | if successful or error code if unsuccessful and *the_info region information block filled in

## ◆ rtems_timer_ident()

rtems_status_code rtems_timer_ident | ( | rtems_name | name,
|  | rtems_id * | id
| ) |  |

RTEMS Timer Name to Id.

This routine implements the rtems_timer_ident directive. This directive returns the timer ID associated with name. If more than one timer is named name, then the timer to which the ID belongs is arbitrary.

Parameters

  [in] | name | is the user defined message queue name
  [in] | id | is the pointer to timer id

Return values

  RTEMS_SUCCESSFUL | if successful or error code if unsuccessful and id filled with the message queue id

## ◆ rtems_timer_initiate_server()

rtems_status_code rtems_timer_initiate_server | ( | rtems_task_priority | priority,
|  | size_t | stack_size,
|  | rtems_attribute | attribute_set
| ) |  |

Initiates the timer server.

This directive creates and starts the server for task-based timers. It must be invoked before any task-based timers can be initiated.

Parameters

  priority | The timer server task priority.
  stack_size | The stack size in bytes for the timer server task.
  attribute_set | The timer server task attributes.

Returns
  This method returns RTEMS_SUCCESSFUL if successful and an error code otherwise.

## ◆ rtems_timer_reset()

rtems_status_code rtems_timer_reset | ( | rtems_id | id | ) |

RTEMS Timer Reset.

Timer Manager - RTEMS Timer Reset

This routine implements the rtems_timer_reset directive. It is used to reinitialize the interval timer associated with ID just as if rtems_timer_fire_after were re-invoked with the same arguments that were used to initiate this timer.

## ◆ rtems_timer_server_fire_after()

rtems_status_code rtems_timer_server_fire_after | ( | rtems_id | id,
|  | rtems_interval | ticks,
|  | rtems_timer_service_routine_entry | routine,
|  | void * | user_data
| ) |  |

RTEMS Timer Server Fire After.

This routine implements the rtems_timer_server_fire_after directive. It initiates the timer associated with ID to fire in ticks clock ticks. When the timer fires, the routine will be invoked by the Timer Server in the context of a task NOT IN THE CONTEXT of the clock tick interrupt.

Parameters

  [in] | id | is the timer id
  [in] | ticks | is the interval until routine is fired
  [in] | routine | is the routine to schedule
  [in] | user_data | is the passed as argument to routine when it is fired

Return values

  This | method returns RTEMS_SUCCESSFUL if there was not an error. Otherwise, a status code is returned indicating the source of the error.

## ◆ rtems_timer_server_fire_when()

rtems_status_code rtems_timer_server_fire_when | ( | rtems_id | id,
|  | rtems_time_of_day * | wall_time,
|  | rtems_timer_service_routine_entry | routine,
|  | void * | user_data
| ) |  |

RTEMS Timer Server Fire When Directive.

Timer Manager - RTEMS Timer Server Fire When Directive

This routine implements the rtems_timer_server_fire_when directive. It initiates the timer associated with ID to fire at wall_time When the timer fires, the routine will be invoked by the Timer Server in the context of a task NOT IN THE CONTEXT of the clock tick interrupt.